Subject: Re: [PATCH 0/2] optimize string hashing in xdiff

From: Junio C Hamano <[email-masked]>
Date: Thu, 14 Aug 2025 08:01:00 -0700

Alexander Monakov <[email-masked]> writes:

>> Using xxhash() was merely a sample code path for technology
>> demonstration, so the Rust adoption topic may want to pick a
>> different code path to do its thing.
>
> My interest here is just speeding up xdiff in C, is that a welcome topic?

I missed this question.  It is very much welcome.

It is not like Rust-minded folks licked this corner of the system
and others cannot touch it ;-)

>> What is the licensing terms for that code you are proposing us to
>> borrow?  If it is anything recent in GNU, I'd expect that it would
>> be GPLv3, which would be incompatible with our code base?
> ...
> I have participated in review of Noah's patches and he kindly listed me as
> a co-author in the final revision of his patchset. So while I'm aware of how
> his code is structured, I had to write a new implementation in order to meet
> the contract of xdl_hash_record_verbatim. Therefore I think I can contribute
> this code on GPLv2 terms with my sign-off.

Thanks for a wonderfully clear description.

I obviously misread the log message of [2/2] and misunderstood that
this was a borrowed code.